## fcidecomp 2.1.1

=== debian/changelog ===
fcidecomp (2.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1091480)

 -- Enrico Zini <enrico@debian.org>  Fri, 27 Dec 2024 16:24:14 +0100

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=cmake

# --with-python3 -D src/fcidecomp/SCF_fcidecomp/

## fcidecomp 2.1.1%2Bdeb1

=== debian/watch ===
# See uscan(1) for format.

# Compulsory line, this is a version 4 file.
version=4

opts="mode=git" https://gitlab.eumetsat.int/open-source/data-tailor-plugins/fcidecomp.git \
    refs/tags/([\d\.]+)

## fcidecomp 2.1.1+deb1

=== src/fcidecomp/fcicomp-H5Zjpegls/CMakeLists.txt ===
# =============================================================
#
# Copyright 2015-2023, European Organisation for the Exploitation of Meteorological Satellites (EUMETSAT)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# =============================================================

# AUTHORS:
# - THALES Services
# - B-Open Solutions srl

# Build the HDF5 JPEG-LS compression-decompression filter.
#
# To provide the module with a hint about where to find your FCICOMP_JPEGLS
# installation, you can set the environment variable FCICOMP_JPEGLS_ROOT. The
# Find module will then look in this path when searching for CharLS
# paths, and libraries.
#
# The module is build with compiler settings in
# ${FCICOMP_RESOURCES_DIR}/compilerFlags.cmake.
# 
# Unit test settings are in
# ${FCICOMP_RESOURCES_DIR}/unitTestSettings.cmake.
# 

cmake_minimum_required (VERSION 2.8.12)
PROJECT (H5ZJPEGLS C)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/Version.cmake)

MESSAGE("")
MESSAGE("**************************")
MESSAGE("   ${PROJECT_NAME}")
MESSAGE("**************************")
MESSAGE("")

# FCICOMP_ROOT should be set
IF (NOT FCICOMP_ROOT)
  # Otherwise try to set the FCICOMP_ROOT to a default value
  SET (FCICOMP_ROOT ${H5ZJPEGLS_SOURCE_DIR}/..)
ENDIF (NOT FCICOMP_ROOT)

# Define where to find the FCICOMP_COMMON source code
SET (FCICOMP_COMMON_SOURCE_DIR ${FCICOMP_ROOT}/fcicomp-common)

#---------------------------------------------------------------------------
# Optional Settings
#---------------------------------------------------------------------------

# Force building with shared libraries instead of static
SET(BUILD_SHARED_LIBS ON)
# Build with logging enable?
OPTION(LOGGING "Enable logging" ON)
# Build the unit tests?
OPTION(BUILD_TESTING "Build unit tests" ON)
OPTION(MEMORY_CHECK "Enable memory check" OFF)
OPTION(COVERAGE_TESTING "Enable coverage testing" OFF)

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
SET (FCICOMP_CMAKE_MODULE_PATH ${FCICOMP_ROOT}/cmake/modules)
SET (FCICOMP_RESOURCES_DIR     ${FCICOMP_ROOT}/cmake/config)

#-----------------------------------------------------------------------------
# Set the path for external cmake modules
#-----------------------------------------------------------------------------
SET (CMAKE_MODULE_PATH ${FCICOMP_CMAKE_MODULE_PATH} ${CMAKE_MODULE_PATH})

#-----------------------------------------------------------------------------
# FCICOMP-JPEGLS Library Settings
# Users can set the FCICOMP_JPEGLS_ROOT variable which is copied to ENV{FCICOMP_JPEGLS_ROOT}
#-----------------------------------------------------------------------------

# Copy the FCICOMP_JPEGLS_ROOT variable retrieved from the cmake command line option 
#  -DFCICOMP_JPEGLS_ROOT into the ENV{FCICOMP_JPEGLS_ROOT} variable used by the FIND_PACKAGE(FCICOMP_JPEGLS_ROOT) command.
SET (ENV{FCICOMP_JPEGLS_ROOT} ${FCICOMP_JPEGLS_ROOT})

# Find FCICOMP_JPEGLS includes and library
FIND_PACKAGE (FCICOMP_JPEGLS REQUIRED)
INCLUDE_DIRECTORIES (${FCICOMP_JPEGLS_INCLUDE_DIR})

#-----------------------------------------------------------------------------
# HDF5 Library Settings
# Users can set the HDF5_ROOT variable which is copied to ENV{HDF5_ROOT}
# ENV{HDF5_ROOT} is used in by FindHDF5.cmake at the call of FIND_PACKAGE(HDF5_ROOT)
#-----------------------------------------------------------------------------

# Copy the HDF5_ROOT variable retrieved from the cmake command line option 
#  -DHDF5_ROOT into the ENV{HDF5_ROOT} variable used by the FIND_PACKAGE(HDF5) command.
IF (HDF5_ROOT)
  MESSAGE("HDF5_ROOT = ${HDF5_ROOT}")
  SET (ENV{HDF5_ROOT} ${HDF5_ROOT})
ENDIF (HDF5_ROOT)

# Find HDF5 includes and library
FIND_PACKAGE (HDF5 REQUIRED)

# Set the HDF5 include directories if they have been found
IF (HDF5_INCLUDE_DIRS)
  MESSAGE("HDF5_INCLUDE_DIRS = ${HDF5_INCLUDE_DIRS}")
  INCLUDE_DIRECTORIES (${HDF5_INCLUDE_DIRS})
ENDIF (HDF5_INCLUDE_DIRS)

#-----------------------------------------------------------------------------
# Set the compiler specific flags 
#-----------------------------------------------------------------------------
INCLUDE (${FCICOMP_RESOURCES_DIR}/compilerFlags.cmake)

#-----------------------------------------------------------------------------
# Set the unit test settings 
#-----------------------------------------------------------------------------
INCLUDE (${FCICOMP_RESOURCES_DIR}/unitTestSettings.cmake)

#-----------------------------------------------------------------------------
# System inspection
#-----------------------------------------------------------------------------

INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES("stdlib.h"       HAVE_STDLIB_H)
CHECK_INCLUDE_FILES("stdio.h"        HAVE_STDIO_H)
CHECK_INCLUDE_FILES("stdarg.h"       HAVE_STDARG_H)
CHECK_INCLUDE_FILES("strings.h"      HAVE_STRINGS_H)

#-----------------------------------------------------------------------------
# Define the rpath settings for the H5Zjpegls library
#-----------------------------------------------------------------------------

# =========== NOTE ON THE HDF5 PLUGIN INSTALLATION DIRECTORY =================
# 
# The default directory for an HDF5 filter plugin library is defined on
# UNIX-like systems as:
#
# /usr/local/hdf5/lib/plugin
#
# It is recommended for users to set the CMAKE_INSTALL_PREFIX variable
# point to the /usr/local directory.
# 
# The default path can be overwritten by a user with the
# HDF5_PLUGIN_PATH environment variable.
#
# ============================================================================

# Set the default installation directory
IF (NOT CMAKE_INSTALL_PREFIX)
  SET (CMAKE_INSTALL_PREFIX "/usr/local")
ENDIF (NOT CMAKE_INSTALL_PREFIX)

# Add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# The RPATH to be used when installing, but only if it's not a system directory
LIST (FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/hdf5/lib/plugin" isSystemDir)
IF ("${isSystemDir}" STREQUAL "-1")
   SET (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/hdf5/lib/plugin")
ENDIF ("${isSystemDir}" STREQUAL "-1")

#-----------------------------------------------------------------------------
# Define H5Zjpegls library
#-----------------------------------------------------------------------------

# Define the name of the library
SET (TARGET_LIBRARY_NAME H5Zjpegls)

# Create the list of source code files
SET (H5ZJPEGLS_SRCS 
    ${H5ZJPEGLS_SOURCE_DIR}/src/H5Zjpegls.c
    ${FCICOMP_COMMON_SOURCE_DIR}/src/fcicomp_log.c
)

# Include the "include" directory
INCLUDE_DIRECTORIES (${H5ZJPEGLS_SOURCE_DIR}/include
    ${FCICOMP_COMMON_SOURCE_DIR}/include)

# Create the H5Zjpegls library
ADD_LIBRARY (${TARGET_LIBRARY_NAME} SHARED ${H5ZJPEGLS_SRCS})
TARGET_LINK_LIBRARIES (${TARGET_LIBRARY_NAME} PRIVATE ${FCICOMP_JPEGLS_LIBRARIES})
TARGET_LINK_LIBRARIES (${TARGET_LIBRARY_NAME} PRIVATE ${HDF5_LIBRARIES})
IF (WIN32)
    # Find ZLIB, this set ZLIB_LIBRARIES
    FIND_PACKAGE (ZLIB REQUIRED)
    TARGET_LINK_LIBRARIES (${TARGET_LIBRARY_NAME} PRIVATE ${ZLIB_LIBRARIES})
ENDIF()

# Set the version and soversion of the library
# this creates the dynamic links
SET_TARGET_PROPERTIES (${TARGET_LIBRARY_NAME} PROPERTIES 
    VERSION ${H5ZJPEGLS_VERSION}
    SOVERSION ${H5ZJPEGLS_SOVERSION})

    
#-----------------------------------------------------------------------------
# Logging settings
#-----------------------------------------------------------------------------

# Define the default logging level
SET (DEFAULT_LOGGING_LEVEL "ERROR_SEVERITY")

# Define the default logging level depending on the debug mode
IF("${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG")
    SET (DEFAULT_LOGGING_LEVEL "DEBUG_SEVERITY")
ENDIF("${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG")


# Enable logging 
IF (LOGGING OR LOGGING_LEVEL)
  SET (EXTRA_COMPILER_FLAGS "-DLOGGING ${EXTRA_COMPILER_FLAGS}")
  
  # Set the logging level
  IF (NOT LOGGING_LEVEL)
    # Set the default logging level
    SET (LOGGING_LEVEL ${DEFAULT_LOGGING_LEVEL})
  ENDIF (NOT LOGGING_LEVEL)

  # Set the logging level
  SET (EXTRA_COMPILER_FLAGS "-DLOGGING_LEVEL=${DEFAULT_LOGGING_LEVEL} ${EXTRA_COMPILER_FLAGS}")

ENDIF (LOGGING OR LOGGING_LEVEL)

#-----------------------------------------------------------------------------
# Set extra compiler flags
#-----------------------------------------------------------------------------

# Test Coverage Settings
IF (COVERAGE_TESTING)
  SET (EXTRA_COMPILER_FLAGS "-fprofile-arcs -ftest-coverage ${EXTRA_COMPILER_FLAGS}")
  SET (EXTRA_LINK_FLAGS_DEBUG "-fprofile-arcs -ftest-coverage ${EXTRA_LINK_FLAGS_DEBUG} ")
ENDIF (COVERAGE_TESTING)

# Add extra compiler flags if any
IF (EXTRA_COMPILER_FLAGS)
  SET_TARGET_PROPERTIES(${TARGET_LIBRARY_NAME} PROPERTIES COMPILE_FLAGS ${EXTRA_COMPILER_FLAGS})
ENDIF (EXTRA_COMPILER_FLAGS)

# Add extra link flags if any
IF (EXTRA_LINK_FLAGS_DEBUG)
  SET_TARGET_PROPERTIES(${TARGET_LIBRARY_NAME} PROPERTIES LINK_FLAGS_DEBUG ${EXTRA_LINK_FLAGS_DEBUG})
ENDIF (EXTRA_LINK_FLAGS_DEBUG)

#-----------------------------------------------------------------------------
# Define the installed components for the H5Zjpegls library
#-----------------------------------------------------------------------------

# Define the PROJECT_NAME_LOWER variable
STRING (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

# Define the include and lib install dir
SET (INCLUDE_INSTALL_DIR include/)
SET (LIBRARY_INSTALL_DIR hdf5/lib/plugin/)

# Install the library
INSTALL (TARGETS ${TARGET_LIBRARY_NAME}
  EXPORT "${PROJECT_NAME_LOWER}-targets"
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  INCLUDES DESTINATION ${INCLUDE_INSTALL_DIR}
)

#  Install include headers
INSTALL (FILES ${H5ZJPEGLS_SOURCE_DIR}/include/H5Zjpegls.h 
  DESTINATION ${INCLUDE_INSTALL_DIR})

#-----------------------------------------------------------------------------
# Create the package
#-----------------------------------------------------------------------------

SET (PROJECT_VERSION ${H5ZJPEGLS_VERSION})
INCLUDE (${FCICOMP_RESOURCES_DIR}/packageConfig.cmake)

#-----------------------------------------------------------------------------
# Unit tests
#-----------------------------------------------------------------------------
IF (BUILD_TESTING)

    # Define the unit tests directory
    SET (TEST_DIR ${H5ZJPEGLS_SOURCE_DIR}/test)
    # Define where the source codes of the unit test are located
    SET (TEST_SOURCE_DIR ${TEST_DIR}/src)
    # Define the directory where are located the test data
    SET (TEST_DATA_DIR ${TEST_DIR}/data)

    #-------------------------------------------------------------------------
    # Define the executables test programs
    #-------------------------------------------------------------------------
    
    # H5Zjpegls_test
    ADD_EXECUTABLE (H5Zjpegls_test
        ${TEST_SOURCE_DIR}/H5Zjpegls_test.c
        ${TEST_SOURCE_DIR}/H5Zjpegls_encode_nominal.c
        ${TEST_SOURCE_DIR}/H5Zjpegls_encode_rgba_nominal.c
        ${TEST_SOURCE_DIR}/H5Zjpegls_encode_cannot_apply.c
        ${TEST_SOURCE_DIR}/H5Zjpegls_decode_nominal.c
	)
    TARGET_LINK_LIBRARIES (H5Zjpegls_test ${HDF5_LIBRARIES})
    IF (WIN32)
        TARGET_LINK_LIBRARIES (H5Zjpegls_test ${ZLIB_LIBRARIES})
    ENDIF()

=== src/fcidecomp/fcicomp-jpegls/CMakeLists.txt ===
# =============================================================
#
# Copyright 2015-2023, European Organisation for the Exploitation of Meteorological Satellites (EUMETSAT)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# =============================================================

# AUTHORS:
# - THALES Services
# - B-Open Solutions srl

# Build the facade between CharLS software and the FCICOMP software.
#
# This CMake script makes use of the FindCHARLS.cmake script to find
# where CharLS library is installed on the system. This FindCHARLS.cmake
# script should be located at ${FCICOMP_ROOT}/cmake/modules. You
# can set the FCICOMP_ROOT environment variable. 
#
# 
# To provide the module with a hint about where to find your CharLS
# installation, you can set the environment variable CHARLS_ROOT. The
# Find module will then look in this path when searching for CharLS
# paths, and libraries.
#
# The facade is build with compiler settings in
# ${FCICOMP_RESOURCES_DIR}/compilerFlags.cmake.
# 
# Unit test settings are in
# ${FCICOMP_RESOURCES_DIR}/unitTestSettings.cmake.
# 

cmake_minimum_required (VERSION 2.8.12)

PROJECT (FCICOMP_JPEGLS C)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/Version.cmake)

MESSAGE ("")
MESSAGE("**************************")
MESSAGE ("   ${PROJECT_NAME}")
MESSAGE("**************************")
MESSAGE ("")

# FCICOMP_ROOT should be set
IF (NOT FCICOMP_ROOT)
  # Otherwise try to set the FCICOMP_ROOT to a default value
  SET (FCICOMP_ROOT ${FCICOMP_JPEGLS_SOURCE_DIR}/..)
ENDIF (NOT FCICOMP_ROOT)

#---------------------------------------------------------------------------
# Optional Settings
#---------------------------------------------------------------------------

# Build with shared libraries instead of static?
OPTION(BUILD_SHARED_LIBS "Build with shared libraries." ON)
# Build with logging enable?
OPTION(LOGGING "Enable logging" ON)
# Build the unit tests?
OPTION(BUILD_TESTING "Build unit tests" ON)
OPTION(MEMORY_CHECK "Enable memory check" OFF)
OPTION(COVERAGE_TESTING "Enable coverage testing" OFF)

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
SET (FCICOMP_CMAKE_MODULE_PATH ${FCICOMP_ROOT}/cmake/modules)
SET (FCICOMP_RESOURCES_DIR     ${FCICOMP_ROOT}/cmake/config)

#-----------------------------------------------------------------------------
# Set the path for external cmake modules
# FindCHARLS.cmake is used to find CHARLS at the call of FIND_PACKAGE (CHARLS)
#-----------------------------------------------------------------------------
SET (CMAKE_MODULE_PATH ${FCICOMP_CMAKE_MODULE_PATH} ${CMAKE_MODULE_PATH})

#-----------------------------------------------------------------------------
# CHARLS Library Settings
# Users can set the CHARLS_ROOT variable which is copied to ENV{CHARLS_ROOT}
# ENV{CHARLS_ROOT} is used in by FindCHARLS.cmake at the call of FIND_PACKAGE(CHARLS)

option (CHARLS_BUILT_DLL "CharLS was built with shared libraries." 1)

if (WIN32)
   if (CHARLS_BUILT_DLL)
     add_definitions(-D CHARLS_DLL)
   else()
     add_definitions(-D CHARLS_STATIC)
   endif()
endif()

#-----------------------------------------------------------------------------

# Copy the CHARLS_ROOT variable retrieved from the cmake command line option 
#  -DCHARLS_ROOT into the ENV{CHARLS_ROOT} variable used by the FIND_PACKAGE(CHARLS_ROOT) command.
SET (ENV{CHARLS_ROOT} ${CHARLS_ROOT})

# Find CHARLS includes and library
FIND_PACKAGE (CHARLS REQUIRED)
INCLUDE_DIRECTORIES (${CHARLS_INCLUDE_DIR})

#-----------------------------------------------------------------------------
# Set the compiler specific flags 
#-----------------------------------------------------------------------------
INCLUDE (${FCICOMP_RESOURCES_DIR}/compilerFlags.cmake)

#-----------------------------------------------------------------------------
# Set the unit test settings 
#-----------------------------------------------------------------------------
INCLUDE (${FCICOMP_RESOURCES_DIR}/unitTestSettings.cmake)

#-----------------------------------------------------------------------------
# System inspection
#-----------------------------------------------------------------------------

INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES("stdlib.h"    HAVE_STDLIB_H)
CHECK_INCLUDE_FILES("stdio.h"     HAVE_STDIO_H)
CHECK_INCLUDE_FILES("stdarg.h"    HAVE_STDARG_H)
CHECK_INCLUDE_FILES("strings.h"   HAVE_STRINGS_H)
CHECK_INCLUDE_FILES("signal.h"    HAVE_SIGNAL_H)
CHECK_INCLUDE_FILES("setjmp.h"    HAVE_SETJMP_H)

#-----------------------------------------------------------------------------
# Define the rpath settings for the fcicomp_jpegls library
#-----------------------------------------------------------------------------

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
   SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF("${isSystemDir}" STREQUAL "-1")

#-----------------------------------------------------------------------------
# Define fcicomp_jpegls library
#-----------------------------------------------------------------------------

# Define the name of the library
SET (TARGET_LIBRARY_NAME fcicomp_jpegls)

# Define where to find the FCICOMP_COMMON source code
SET (FCICOMP_COMMON_SOURCE_DIR ${FCICOMP_ROOT}/fcicomp-common)

# Create the list of source code files
SET (FCICOMP_JPEGLS_SRCS 
    ${FCICOMP_JPEGLS_SOURCE_DIR}/src/fcicomp_jpegls.c
    ${FCICOMP_COMMON_SOURCE_DIR}/src/fcicomp_log.c
)

# Include the directories
INCLUDE_DIRECTORIES (${FCICOMP_JPEGLS_SOURCE_DIR}/include 
    ${FCICOMP_COMMON_SOURCE_DIR}/include)

# Create the fcicomp_jpegls library
ADD_LIBRARY (${TARGET_LIBRARY_NAME} ${FCICOMP_JPEGLS_SRCS})
TARGET_LINK_LIBRARIES (${TARGET_LIBRARY_NAME} PRIVATE ${CHARLS_LIBRARIES})

# Set the version and soversion of the library
# this creates the dynamic links
SET_TARGET_PROPERTIES (${TARGET_LIBRARY_NAME} PROPERTIES 
    VERSION ${FCICOMP_JPEGLS_VERSION}
    SOVERSION ${FCICOMP_JPEGLS_SOVERSION})


#-----------------------------------------------------------------------------
# Logging settings
#-----------------------------------------------------------------------------

# Define the default logging level
SET (DEFAULT_LOGGING_LEVEL "ERROR_SEVERITY")

# Define the default logging level depending on the debug mode
IF("${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG")
    SET (DEFAULT_LOGGING_LEVEL "DEBUG_SEVERITY")
ENDIF("${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG")

# Enable logging 
IF (LOGGING OR LOGGING_LEVEL)
  SET (EXTRA_COMPILER_FLAGS "-DLOGGING ${EXTRA_COMPILER_FLAGS}")
  
  # Set the logging level
  IF (NOT LOGGING_LEVEL)
    # Set the default logging level
    SET (LOGGING_LEVEL ${DEFAULT_LOGGING_LEVEL})
  ENDIF (NOT LOGGING_LEVEL)

  # Set the logging level
  SET (EXTRA_COMPILER_FLAGS "-DLOGGING_LEVEL=${DEFAULT_LOGGING_LEVEL} ${EXTRA_COMPILER_FLAGS}")

ENDIF (LOGGING OR LOGGING_LEVEL)

#-----------------------------------------------------------------------------
# Set extra compiler flags
#-----------------------------------------------------------------------------

# Test Coverage Settings
IF (COVERAGE_TESTING)
  SET (EXTRA_COMPILER_FLAGS "-fprofile-arcs -ftest-coverage ${EXTRA_COMPILER_FLAGS}")
  SET (EXTRA_LINK_FLAGS_DEBUG "-fprofile-arcs -ftest-coverage ${EXTRA_LINK_FLAGS_DEBUG} ")
ENDIF (COVERAGE_TESTING)

# Add extra compiler flags if any
IF (EXTRA_COMPILER_FLAGS)
  SET_TARGET_PROPERTIES(${TARGET_LIBRARY_NAME} PROPERTIES COMPILE_FLAGS ${EXTRA_COMPILER_FLAGS})
ENDIF (EXTRA_COMPILER_FLAGS)

# Add extra link flags if any
IF (EXTRA_LINK_FLAGS_DEBUG)
  SET_TARGET_PROPERTIES(${TARGET_LIBRARY_NAME} PROPERTIES LINK_FLAGS_DEBUG ${EXTRA_LINK_FLAGS_DEBUG})
ENDIF (EXTRA_LINK_FLAGS_DEBUG)

#-----------------------------------------------------------------------------
# Define the installed components for the fcicomp_jpegls library
#-----------------------------------------------------------------------------

# Define the PROJECT_NAME_LOWER variable
STRING (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

# Define the include and lib install dir
SET (INCLUDE_INSTALL_DIR include/)
SET (LIBRARY_INSTALL_DIR lib/)

# Install the library
INSTALL (TARGETS ${TARGET_LIBRARY_NAME}
  EXPORT "${PROJECT_NAME_LOWER}-targets"
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  INCLUDES DESTINATION ${INCLUDE_INSTALL_DIR}
)

# Install include headers
INSTALL (FILES ${FCICOMP_JPEGLS_SOURCE_DIR}/include/fcicomp_jpegls.h 
  DESTINATION ${INCLUDE_INSTALL_DIR})

#-----------------------------------------------------------------------------
# Create the package
#-----------------------------------------------------------------------------

SET (PROJECT_VERSION ${FCICOMP_JPEGLS_VERSION})
INCLUDE (${FCICOMP_RESOURCES_DIR}/packageConfig.cmake)

#-----------------------------------------------------------------------------
# Unit tests
#-----------------------------------------------------------------------------

IF (BUILD_TESTING)

    # Define the unit tests directory
    SET (TEST_DIR ${FCICOMP_JPEGLS_SOURCE_DIR}/test)
    # Define where the source codes of the unit test are located
    SET (TEST_SOURCE_DIR ${TEST_DIR}/src)
    # Define the directory where are located the test data
    SET (TEST_DATA_DIR ${TEST_DIR}/data)


    #-------------------------------------------------------------------------
    # Define the executables test programs
    #-------------------------------------------------------------------------
    
    # jpegls_test
    ADD_EXECUTABLE (jpegls_test
        ${TEST_SOURCE_DIR}/jpegls_test.c
        ${TEST_SOURCE_DIR}/jpegls_compress_nominal.c
        ${TEST_SOURCE_DIR}/jpegls_decompress_nominal.c
        # ${TEST_SOURCE_DIR}/jpegls_compress_error_case.c
        ${TEST_SOURCE_DIR}/jpegls_read_header_error_case.c
        ${TEST_SOURCE_DIR}/jpegls_decompress_error_case.c
	)
    TARGET_LINK_LIBRARIES (jpegls_test ${TARGET_LIBRARY_NAME})
    SET_TARGET_PROPERTIES(jpegls_test PROPERTIES COMPILE_FLAGS "-DLOGGING")

    #-------------------------------------------------------------------------
    # Define the test image
    #-------------------------------------------------------------------------
 
    # sample
    # ------

    # Define the test image name, size and bpp
    SET (TEST_SAMPLE_IMAGE_NAME "sample")
    SET (TEST_SAMPLE_IMAGE_SIZE "200;100")
    SET (TEST_SAMPLE_IMAGE_BPP "16")
    # Define the reference uncompressed image file
    SET (REF_SAMPLE_RAW_FILE "${TEST_DATA_DIR}/${TEST_SAMPLE_IMAGE_NAME}_ref.raw")
    # Define the reference compressed image file
    SET (REF_SAMPLE_JLS_FILE "${TEST_DATA_DIR}/${TEST_SAMPLE_IMAGE_NAME}_ref.jls")

    # noise_sample
    # -----------

    # Define the test RGBA image name, size and bpp
    SET (TEST_NOISE_SAMPLE_IMAGE_NAME "noise_sample")
    SET (TEST_NOISE_SAMPLE_IMAGE_SIZE "32;32")
    SET (TEST_NOISE_SAMPLE_IMAGE_BPP "16")
    # Define the reference uncompressed image file
    SET (REF_NOISE_SAMPLE_RAW_FILE "${TEST_DATA_DIR}/${TEST_NOISE_SAMPLE_IMAGE_NAME}_ref.raw")
    # Define the reference compressed image file

=== debian/changelog ===
fcidecomp (2.1.1+deb1-1) unstable; urgency=medium

  * Aligned with upstream tag 2.1.1
  * Bump minimum cmake compat to 3.5 to build with cmake4
  * Added README.source to explain what is going on

 -- Enrico Zini <enrico@debian.org>  Sun, 28 Sep 2025 12:33:35 +0200

=== debian/control ===
Source: fcidecomp
Section: libs
Priority: optional
Maintainer: Enrico Zini <enrico@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.15),
 libhdf5-dev,
 libcharls-dev,
Standards-Version: 4.6.2
Homepage: https://gitlab.eumetsat.int/open-source/data-tailor-plugins/fcidecomp
Vcs-Browser: https://salsa.debian.org/science-team/fcidecomp
Vcs-Git: https://salsa.debian.org/science-team/fcidecomp.git

Package: libfcidecomp-jpegls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfcidecomp-jpegls1 (= ${binary:Version}),
 ${misc:Depends},
Description: fcicomp interface to charls JPEG-LS library (development files)
 This library provides an interface to the charls library for use by the
 fcicomp-H5Zjpegls plugin

Package: libfcidecomp-jpegls1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: fcicomp interface to charls JPEG-LS library
 This library provides an interface to the charls library for use by the
 fcicomp-H5Zjpegls plugin

Package: libh5z-jpegls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 hdf5-filter-plugin-fcidecomp-serial (= ${binary:Version}),
 ${misc:Depends},
Description: HDF5 JPEG-LS compression-decompression filter (development files)
 This is the development interface to the JPEG-LS filter plugin for HDF5

Package: hdf5-filter-plugin-fcidecomp-serial
Provides: hdf5-filter-plugin-fcidecomp
Conflicts: hdf5-filter-plugin-fcidecomp
Replaces: hdf5-filter-plugin-fcidecomp
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: HDF5 JPEG-LS compression-decompression filter
 This is a HDF5 filter plugin that enables decompression of JEPG-LS HDF5/NetCDF
 file.
 .
 This filter plugin is required to access EUMETSAT Meteosat Third Generation
 (MTG) NetCDF files.

=== debian/tests/control ===
Test-Command: python3 -c 'import sys, h5py; sys.exit(not h5py.h5z.filter_avail(32018))'
Depends: python3, python3-h5py, @
Restrictions: allow-stderr
